require 'nested_struct/version'

require 'nested_struct/errors/invalid_coercer_expression'
require 'nested_struct/errors/invalid_coercer_target'
require 'nested_struct/errors/invalid_coercer_value'

require 'nested_struct/configuration'
require 'nested_struct/empty'

require 'nested_struct/coercer'
require 'nested_struct/field'

require 'nested_struct/interface'

module NestedStruct
  EMPTY = self::Empty.instance

  class << self
    def configuration
      @configuration ||= Configuration.new
    end

    def configure
      yield(configuration) if block_given?
      configuration
    end
  end
end
